<?php

namespace Teknisa\ACL\Util;

use ZeedhiUser\Factory\AccessControl;
use Teknisa\Libs\Util\ConnectionFactory;
use Doctrine\Common\EventManager;
use Doctrine\ORM\Configuration;
use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\Session\Session;

class EntityManagerFactory extends AccessControl\EntityManagerFactory {
    public static function create($conn, Configuration $config, EventManager $eventManager = null, Session $session = null) {
        if ( ! $config->getMetadataDriverImpl()) {
            throw ORMException::missingMappingDriverImpl();
        }

        switch (true) {
            case (is_array($conn)):
                $conn = self::createConnection($conn, $config, $eventManager, $session);
                break;

            default:
                throw new \InvalidArgumentException("The argument should be an array: " . $conn);
        }

        return new EntityManager($conn, $config, $conn->getEventManager());
    }

    protected static function createConnection($conn, $config, EventManager $eventManager = null, Session $session = null) {
        return ConnectionFactory::updateConnectionParams($conn, $config, ($eventManager ?: new EventManager()), $session);
    }
} 